<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<title>magpar: Programming, Debugging, Bug Reporting</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<link href="doxygen.css" rel="stylesheet" type="text/css"/>
</head>
<body>
<!-- Generated by Doxygen 1.6.3 -->
<div class="navigation" id="top">
  <div class="tabs">
    <ul>
      <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
      <li class="current"><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Data&nbsp;Structures</span></a></li>
      <li><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
</div>
<div class="contents">


<h1><a class="anchor" id="bug">Programming, Debugging, Bug Reporting </a></h1><hr/>
<p>Sections:</p>
<ul>
<li><a class="el" href="bug.html#programming_general">General programming guidelines</a></li>
<li><a class="el" href="bug.html#debugging">Debugging</a></li>
<li><a class="el" href="bug.html#guidelines">Guidelines for bug reports</a></li>
</ul>
<hr/>
<h2><a class="anchor" id="programming_general">
General programming guidelines</a></h2>
<p>Formatting:</p>
<ul>
<li>There are no "tabs" (except in Makefiles where necessary).</li>
<li>Indent each level by 2 spaces</li>
<li>Opening parentheses, braces are never on a line of their own</li>
</ul>
<p>Variables:</p>
<ul>
<li>Avoid global variables (especially in the <a class="el" href="structGridData.html">GridData</a> structure)</li>
<li>Use local variables wherever possible</li>
</ul>
<p>Simple templates for magpar functions:</p>
<p>Initialization function (called during serial or parallel initialization): </p>
<div class="fragment"><pre class="fragment"><span class="keywordtype">int</span> MagparFunctionInit(<a class="code" href="structGridData.html">GridData</a> *gdata,Vec vec1,PetscReal *real1)
{
  <span class="comment">/* First executable line of each PETSc function used for error handling. */</span>
  <span class="comment">/* macros defined in griddata.h, see also PetscFunctionBegin */</span>
  <span class="comment">/* print log information on stdout (source file, function name) */</span>
  <a class="code" href="griddata_8h.html#a3d9da926137619fd02adb245a08536c7">MagparFunctionLogBegin</a>;

  [<span class="keywordflow">do</span> stuff]

  <span class="comment">/* print timing information */</span>
  <a class="code" href="griddata_8h.html#a8491466d8534a33d7163f5ea747e8210">MagparFunctionLogReturn</a>(0);
}
</pre></div><p>Solver function (called many times during solution): </p>
<div class="fragment"><pre class="fragment"><span class="keywordtype">int</span> MagparFunction(<a class="code" href="structGridData.html">GridData</a> *gdata,Vec vec1,PetscReal *real1)
{
  <span class="comment">/* by default do not print any information on stdout */</span>
  <span class="comment">/* if &quot;-info&quot; option is active: print log information on stdout */</span>
  <a class="code" href="griddata_8h.html#a4e81d68a7df0ff55ea65b46253e07552">MagparFunctionInfoBegin</a>;

  [<span class="keywordflow">do</span> stuff]

  <span class="comment">/* by default do not print any information on stdout */</span>
  <span class="comment">/* if &quot;-info&quot; option is active: print timing information on stdout */</span>
  <a class="code" href="griddata_8h.html#a3a0efa409c6998ac8e9d7b30da6a8171">MagparFunctionInfoReturn</a>(0);
}
</pre></div><hr/>
<h2><a class="anchor" id="debugging">
Debugging</a></h2>
<p>The following suggestions might be helpful for debugging:</p>
<ul>
<li>Additional PETSc options <br/>
 Before submitting any bug reports, please rerun your simulation including the additional configuration file with PETSc internal logging/info/diagnostic options contained in <a class="el" href="allopttxt.html#allopt_log_txt">allopt_log.txt</a> (especially the memory checking and "-info" options), which might give some more detailed information about the cause of the problem.</li>
</ul>
<ul>
<li>Running magpar in a debugger for serial runs <br/>
 Just like any other program you can run magpar in a debugger (e.g. gdb) or use the PETSc option "-on_error_attach_debugger [gdb,dbx,xxgdb,ups,noxterm]" to attach to a debugger on error (see <a class="el" href="allopttxt.html#allopt_log_txt">allopt_log.txt</a>, <a href="http://www.mcs.anl.gov/petsc/petsc-as/documentation/index.html">PETSc Documentation</a>, <a href="http://www.mcs.anl.gov/petsc/petsc-as/snapshots/petsc-current/docs/manual.pdf">PETSc users manual</a>). Use the PETSc option "-display" to define the location where graphics and debuggers are to be displayed.</li>
</ul>
<ul>
<li>Running magpar in a debugger for parallel runs <br/>
 The "-on_error_attach_debugger" option even works for parallel runs, where separate xterms will pop up for each rank. For convenience it is useful to run parallel debugging runs on the local development machine. The number of parallel threads can exceed the number of processors/cores, of course. So you can debug a parallel run also on a single processor machine.</li>
</ul>
<ul>
<li>printf <br/>
 Often it is more convenient and efficient to debug using the "printf" technique. In the context of PETSc based programs like magpar this includes functions, which print also more sophisticated parallel data structures, e.g. <a class="el" href="hdemag_8c.html#a550cd909b1c224ef8c259dd68298e50a">hdemag.c::Hdemag_Init</a> : <div class="fragment"><pre class="fragment">  PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;deb01: Au1\n&quot;</span>);
  ierr = MatView(Au1,PETSC_VIEWER_STDOUT_WORLD);CHKERRQ(ierr);
  PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;deb02: u1\n&quot;</span>);
  ierr = VecView(u1,PETSC_VIEWER_STDOUT_WORLD);CHKERRQ(ierr);

  <span class="comment">/* get output from all processors */</span>
  PetscBarrier(PETSC_NULL);
  PetscSynchronizedPrintf(PETSC_COMM_WORLD,
    <span class="stringliteral">&quot;[%i]deb03:  %i %g!\n&quot;</span>,rank,intvar,doublevar
  );
  PetscSynchronizedFlush(PETSC_COMM_WORLD);
</pre></div></li>
</ul>
<p>In addition, it is often useful to ensure that all parallel processes are synchronized at a certain position in the program. This is easily accomplished by using the PETSc function "PetscBarrier", which blocks until this routine is executed by all processors owning a certain PETSc object, e.g. the global magnetization vector "gdata-&gt;M". </p>
<div class="fragment"><pre class="fragment">  PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;deb03: barrier\n&quot;</span>);
  PetscBarrier(PETSC_NULL);
</pre></div><hr/>
<h2><a class="anchor" id="guidelines">
Guidelines for bug reports</a></h2>
<p>Required information:</p>
<ul>
<li>magpar version, original distribution or patched/modified version</li>
<li>a detailed description with copies of the error messages from compiler, program, etc.</li>
<li>compiler name and version (e.g. GNU gcc, GNU g++, cc)</li>
<li>versions of all used libraries: PETSc, MPI, BLAS, LAPACK, ATLAS, Sundials, etc.</li>
<li>operating system: name, version, release, (Linux distribution)</li>
<li>machine/hardware type</li>
</ul>
<p>The more information you provide, the easier it is to track down the problem.</p>
<p>Bug reports may be sent to: magpar(at)magpar.net </p>
</div>
  <hr>
  <address>
    magpar - Parallel Finite Element Micromagnetics Package<br>
    Copyright (C) 2002-2010 Werner Scholz
  </address>
  </body>
</html>

